library(geosphere)
library(lubridate)
library(data.table)
source('Funcoes.R', local=TRUE)
library(shiny)
DIST_THR = 50
stop_time = NULL
time_stops_dataset =list()
TCS_stops_dataset = list()
ID_LINHA = 0
DATA_INICIO = ""
DATA_FIM = ""
circulino_bus_ids = NULL

LINE_PAR_CHANGE_FLAG = 0

#setwd ('/Users/daniel_pc/iCloud Drive (Arquivo)/Documents/UNICAMP/2019.1/IA376A/Bus_Data')
#source('/Users/daniel_pc/iCloud Drive (Arquivo)/Documents/UNICAMP/2019.1/IA376A/Bus_Data/Funcoes.R', echo=TRUE)
source('Funcoes.R', local=TRUE)
#path_file = paste(getwd(),"/circular_pontos_por_linha.csv", collapse = NULL, sep = "")

#Bus_Stops = read.table(file=path_file,header=T,sep=";", dec=".",stringsAsFactors = FALSE)
Bus_Stops = read.table(file='circular_pontos_por_linha.csv',header=T,sep=";", dec=".",stringsAsFactors = FALSE)


  print("Aguarde, Leitura dos dados sendo efetuadas")
  #source('/Users/daniel_pc/iCloud Drive (Arquivo)/Documents/UNICAMP/2019.1/IA376A/Bus_Data/Leitura_Circulino.R', echo=TRUE)
  ###SCRIPT LEITURA CIRCULINO
  ###Obtenção dos dados para análise
  
  #Arquivo Grande
  #path_file = paste(getwd(),"/coordenadas_01-01-2018-a-30-01-2019.csv", collapse = NULL, sep = "")
  #Arquivo Pequeno
  #path_file = paste(getwd(),"/coordenadas_16-07-2018-a-20-07-2018.csv", collapse = NULL, sep = "")
  
  
  #Bus_Data <<- read.table(file="coordenadas_16-07-2018-a-20-07-2018.csv",header=T,sep=",", dec=".",stringsAsFactors = FALSE)
  Bus_Data <<- read.table(file="coordenadas_01-01-2018-a-30-01-2019.csv",header=T,sep=",", dec=".",stringsAsFactors = FALSE)
  
  #Coloca tempo e data num formato razoável para operações
  #Bus_Data$hora_coletado = strptime(Bus_Data$hora_coletado, format = '%d/%m/%Y %H:%M:%S')
  #Formato - Segundo Teste
  Bus_Data$hora_coletado <<- strptime(Bus_Data$hora_coletado, format = '%Y-%m-%d %H:%M:%S')


ui <- fluidPage(
  titlePanel("Painel Analisador de Histórico de Tráfego"),
  sidebarLayout
  (
    sidebarPanel
    (
      
      selectInput(inputId = "line_selection", label = "Selecione as Linhas de ônibus:", choices =  unique(Bus_Stops$linha)),
      textInput("start_date_selection", "Insira a data início:", "AAAA-MM-DD"),
      textInput("end_date_selection", "Insira a data fim:", "AAAA-MM-DD"),
      actionButton(inputId = "read_BusData_FLAG", "Processar")
      
    ),
    mainPanel(tabsetPanel(type = "tab",
                          tabPanel("Sumário", div(mainPanel("Seja bem vindo ao analisador de tráfego.\n
                                                        Coloque os dados de interesse no painel ao lado para 
                                                        gerar os gráficos.\n\n"), style="clear:left;"), h5(div(textOutput("bus_used"), style="clear:left;" ))   ),
                          tabPanel("Análise TCS - Itinerário",
                                   fluidRow(
                                     column(8, plotOutput("itinerary_TCS")),
                                     column(4, plotOutput("itinerary_TCS_legend"))
                                   )
                          ),
                          
                          # plotOutput("itinerary_TCS"),
                          #  plotOutput( )),
                          tabPanel("Análise TCS de trechos - Hora", 
                                   textInput("frag_input_number", "Insira o número do trecho do ponto de ônibus:"),
                                   actionButton(inputId = "read_frag_input_number_FLAG", "Gerar"),
                                   plotOutput("TCS_time")) 
                          
    )
    )
    
    
    
  )
  
  
  
  
  
)

server <- function(input, output)
{
  
  observeEvent(input$read_BusData_FLAG, 
               {
                 #print(input$read_BusData_FLAG)
                 
                 LINE_PAR_CHANGE_FLAG <<- 1
                 
                 ID_LINHA <<- input$line_selection
                 DATA_INICIO <<- input$start_date_selection
                 DATA_FIM <<- input$end_date_selection
                 
                 
                 #FILTRAGEM CIRCULINO
                 #source('/Users/daniel_pc/iCloud Drive (Arquivo)/Documents/UNICAMP/2019.1/IA376A/Bus_Data/Filtragem_Circulino.R', local=TRUE)
                 #source('Filtragem_Circulino.R', local=TRUE)
                 #FILTRAGEM CIRCULINO
                 
                 FtBus_Data =subset(Bus_Data, id_linha == ID_LINHA)#, id_circulino == ID_CIRCULINO)
                 FtBus_Data = subset(FtBus_Data, hora_coletado > DATA_INICIO)
                 FtBus_Data = subset(FtBus_Data, hora_coletado < DATA_FIM)
                 
                 Bus_Stops = subset(Bus_Stops, linha == ID_LINHA)
                 circulino_bus_ids <<- as.numeric(sort(unique(FtBus_Data$id_circulino)))
                 output$bus_used <- renderText({paste("\n\nProcessamento da linha ", as.character(ID_LINHA),  " terminado.\nOs Ônibus utilizados nessa linha são:",
                                                      paste(as.character(circulino_bus_ids), collapse = ", "), collapse = " ")})
                 #source('/Users/daniel_pc/iCloud Drive (Arquivo)/Documents/UNICAMP/2019.1/IA376A/Bus_Data/Processamento_Circulino.R', echo=TRUE)
                 
                 ##PROCESSAMENTO CIRCULINO SCRIPT
                 #Gerar distancia para todos os pontos de onibus
                 dist = matrix(, nrow = length(FtBus_Data$latitude), ncol = length(Bus_Stops$referencia))
                 stop_moment = matrix(, nrow = length(FtBus_Data$latitude), ncol = length(Bus_Stops$referencia))
                 stop_time <<- matrix(, nrow = length(FtBus_Data$latitude), ncol = length(Bus_Stops$referencia))
                 
                 colnames(dist) <- Bus_Stops$referencia
                 colnames(stop_moment) <- Bus_Stops$referencia
                 colnames(stop_time) <<- Bus_Stops$referencia
                 
                 for (x in 1:length(Bus_Stops$longitude))
                 {
                   dist[,x] = geodist(FtBus_Data$longitude, FtBus_Data$latitude, Bus_Stops$longitude[x], Bus_Stops$latitude[x])
                 }
                 
                 total <- length(Bus_Stops$longitude)
                 # create progress bar
                 pb <- txtProgressBar(min = 0, max = total, style = 3)
                 
                 #algoritmo para associar chegadas em paradas de ônibus
                 for (x in 1:length(Bus_Stops$longitude))
                 {
                   y = 1
                   setTxtProgressBar(pb, x)
                   while (y < length(FtBus_Data$latitude))
                   {
                     y = y + 1
                     if(is.na(dist[y,x]) == FALSE)
                     {
                       if (dist[y,x] < DIST_THR)
                       {
                         tempy = y
                         while(dist[y,x] <DIST_THR & y < length(FtBus_Data$latitude) - 1)
                         {
                           y = y+1
                           if (y == length(FtBus_Data$latitude) - 1)
                             break
                           
                           
                           if (dist[y,x] < dist[tempy, x])
                             tempy = y
                         }
                         stop_moment[tempy, x] =TRUE
                       }
                     }
                   }
                 }
                 close(pb)
                 aux = which(stop_moment, TRUE)
                 stop_time <<- matrix(,nrow= nrow(aux), ncol = ncol(aux) + 2)
                 
                 
                 
                 for (i in 1:length(aux[,1]))
                 {
                   stop_time[i,1] <<- as.character(FtBus_Data$hora_coletado[aux[i,1]])
                   stop_time[i,2] <<- Bus_Stops$referencia[aux[i,2]]
                   stop_time[i,3] <<- dist[aux[i,1],  aux[i,2]]
                   stop_time[i,4] <<- as.character(FtBus_Data$id_circulino[aux[i,1]])
                 }
                 
                 colnames(stop_time) <<- c("Hora", "Parada", "distancia", "id_circulino")
                 stop_time <<- stop_time[order(stop_time[,"Hora"]),]
                 
                 rm(stop_moment)
                 rm(dist)
                 
                 ##########################################################
                 
                 #source('/Users/daniel_pc/iCloud Drive (Arquivo)/Documents/UNICAMP/2019.1/IA376A/Bus_Data/Extracao_Circulino.R', echo=TRUE)
                 ##EXTRAÇÃO CIRCULINO CIRCULINO SCRIPT
                 
                 time_stops_dataset <<- list()
                 TCS_stops_dataset <<- list()
                 ###### Dar abertura para filtragem de ônibus aqui
                 circulino_bus_ids <<- as.numeric(sort(unique(stop_time[,"id_circulino"])))
                 ##############
                 
                 
                 for (i in 1:(length(Bus_Stops$referencia) - 1))
                 {
                   bstop_data = c(Bus_Stops$referencia[i], Bus_Stops$referencia[i+1])
                   temp_set <- data.frame(time_dif_data =numeric(),
                                          time_dif_dayhour=character())
                   #print(paste(Bus_Stops$referencia[i], "->", Bus_Stops$referencia[i+1]))
                   for (j in 1:length(circulino_bus_ids))
                   {
                     stp = stop_time[(stop_time[, "Parada"] == bstop_data[1] | stop_time[, "Parada"] == bstop_data[2]) & stop_time[, "id_circulino"] == circulino_bus_ids[j],]
                     temp = time_dif_data(stp, bstop_data)
                     if (!is.null(temp))
                     {
                       temp_set = rbind(temp_set, temp)
                     }
                   }
                   if (length(temp_set[,1]) > 0)
                   {
                     temp_set = remove_outliers(temp_set)
                     temp_set = remove_outliers(temp_set)
                     temp_set = remove_outliers(temp_set)
                     
                     temp_name = paste(Bus_Stops$referencia[i], "->", Bus_Stops$referencia[i+1])
                     
                     temp_list = list(temp_set)
                     names(temp_list) <- temp_name
                     
                     temp_TCS = time2TCS(temp_set)
                     
                     temp_TCS_list = list(temp_TCS)
                     names(temp_TCS_list) <- temp_name
                     
                     TCS_stops_dataset <<- append(TCS_stops_dataset,temp_TCS_list) 
                     time_stops_dataset <<- append(time_stops_dataset,temp_list) 
                   }
                 }
                 
                 ####SEÇÃO PARA PLOT TCS = f(ITINERARIO)
                 legend_name_set = c()
                 TCS_stops= list()
                 for (i in 1:length(TCS_stops_dataset))
                 {
                   temp = TCS_stops_dataset[[i]][1]
                   names(temp) = names(TCS_stops_dataset)[i]
                   names(temp) = paste(i, ":", i+1, sep = "")
                   TCS_stops = append(TCS_stops,temp)
                   
                   line_legend = paste(i, ": ", Bus_Stops$abreviatura[i], sep = "")
                   # print(line_legend)
                   legend_name_set = append(legend_name_set, line_legend)
                 }
                 line_legend = paste(i+1, ": ", Bus_Stops$abreviatura[i+1], sep = "")
                 legend_name_set = append(legend_name_set, line_legend)
                 output$itinerary_TCS <- renderPlot({
                   par(las=2)
                   par(mar = c(3.0, 4.1, 4.3, 6.6))
                   boxplot(TCS_stops, ylim = c(0,1), cex.axis = "0.8",ylab = "TCS", main = paste("Análise de TCS para Circular Interno\nLinha:", ID_LINHA, "Ônibus:", paste(circulino_bus_ids, collapse=", "), "\nde", 
                                                                                                 DATA_INICIO, "até", DATA_FIM))
                   #legend("topright", inset = c(-0.43, -0.28), legend=legend_name_set, cex=0.6, xpd=TRUE, title = "Pontos de Ônibus", text.font = 1)
                   #legend("topright",inset = c(-0.0, -0.0),legend=legend_name_set, xpd=TRUE, title = "Pontos de Ônibus", text.font = 1)
                 })
                 output$itinerary_TCS_legend <- renderPlot({
                   
                   plot(0,type='n',axes=FALSE,ann=FALSE)
                   #legend("topright", inset = c(-0.43, -0.28), legend=legend_name_set, cex=0.6, xpd=TRUE, title = "Pontos de Ônibus", text.font = 1)
                   legend("center", cex = 0.6, legend=legend_name_set, xpd=TRUE, title = "LEGENDA - PONTOS DE ÔNIBUS", text.font = 1)
                 })
                 output$itinerary_TCS_legend_label <- renderText("Legenda")
                 #output$itinerary_TCS_legend <- renderText((paste(legend_name_set[1:5], collapse = '; ')))
                 
                 # print("Cheguei até o final")
               })
  
  observeEvent(input$read_frag_input_number_FLAG, 
               {
                 if(input$read_frag_input_number_FLAG == 1 || LINE_PAR_CHANGE_FLAG == 1)
                   #if(LINE_PAR_CHANGE_FLAG == 1)
                 {
                  # print("Entrei aqui")
                  # print("TCS_stops_dataset: ")
                  # print(length(TCS_stops_dataset))
                   LINE_PAR_CHANGE_FLAG <<- 0
                   time_stops_dataset_rounded <<- time_stops_dataset
                   TCS_stops_dataset_rounded <<- TCS_stops_dataset
                   
                   
                   for (i in 1:length(time_stops_dataset_rounded))
                   {
                     time_stops_dataset_rounded[[i]][,2] <<- as.character(as.ITime(floor_date(as.POSIXct(TCS_stops_dataset[[i]][,2]), "30 mins")))
                     time_stops_dataset_rounded[[i]][,2] <<- substr(time_stops_dataset_rounded[[i]][,2], 1, nchar(time_stops_dataset_rounded[[i]][,2]) -3)
                     
                     TCS_stops_dataset_rounded[[i]][,2] <<- as.character(as.ITime(floor_date(as.POSIXct(TCS_stops_dataset[[i]][,2]), "30 mins")))
                     TCS_stops_dataset_rounded[[i]][,2] <<- substr(time_stops_dataset_rounded[[i]][,2], 1, nchar(TCS_stops_dataset_rounded[[i]][,2]) -3)
                   }
                 }
                 
                 PTO_IDX = as.numeric(input$frag_input_number)
                 ref = paste(Bus_Stops$referencia[PTO_IDX], "->", Bus_Stops$referencia[PTO_IDX+1])
                 
                 print("-----------------------------TCS[ref]")
                 print(TCS_stops_dataset_rounded[PTO_IDX])
                 TCS_time = TCS_stops_dataset_rounded[PTO_IDX]
                 #print(TCS_stops_dataset_rounded)
                 #print("Cheguei Aqui")
                 
                 hours_domain = sort(unlist(unique(TCS_time[[1]][2]), use.names = FALSE))
                 
                 TCS_score_avg_set = NULL#matrix(ncol = 2, nrow = length(hours_domain))
                 
                 for (i in 1:length(hours_domain))
                 {
                   TCS_score_avg_set[i] = mean(unlist(subset(TCS_time[[1]], time_dif_dayhour == hours_domain[i])[1]))
                   # temp[i][2] = hours_domain[i]
                 }
                 
                 TCS_score_avg = list("TCS_medio" = TCS_score_avg_set, "Hora" = hours_domain)
                 
                 main_title = paste("TCS médio em função da hora\nLinha: ", ID_LINHA, "; Ônibus: ", 
                                    paste(circulino_bus_ids, collapse=", "),"; entre ", DATA_INICIO, " e ", 
                                    DATA_FIM,  "\nTrecho: ", names(TCS_time), sep = "") 
                 
                 
                 
                 
                 output$TCS_time <- renderPlot({
                   #PLOT COM BOXPLOT
                   # par(mar=c(5.1, 4.1, 4.1, 2.1), mgp=c(3, 1, 0), las=0)
                   # boxplot(TCS_time[[1]][,1] ~ TCS_time[[1]][,2], ylim = c(0,1), ylab = "TCS", cex.axis =0.7,
                   #         main = paste("TCS em função da hora\nLinha: ", ID_LINHA, "; Ônibus:", 
                   #                      paste(circulino_bus_ids, collapse=", "),"\nEntre ", DATA_INICIO, " e ", DATA_FIM,  "\nTrecho: ", names(TCS_time), sep = ""), 
                   #         cex.main = 0.7)
                   # PLOT DE TCS MEDIO
                   par(mar=c(5.1, 4.1, 4.1, 2.1), mgp=c(3, 1, 0), las=0)
                   plot(1:length(TCS_score_avg[[2]]), TCS_score_avg[[1]] , ylim = c(0,1), ylab = "TCS médio", xlab = "Hora",
                        type="o", col = 'red', main = main_title, xaxt='n')
                   axis(side = 1, at= 1:length(TCS_score_avg[[2]]), labels=TCS_score_avg[[2]])
                   lines(1:length(TCS_score_avg[[2]]), TCS_score_avg[[1]] , ylim = c(0,1), type="l", col = 'black', ) 
                   axis(side = 1, at= 1:length(TCS_score_avg[[2]]), labels=TCS_score_avg[[2]])
                   
                 })
               })
}
shinyApp(ui = ui, server = server)